// VCDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "stdlib.h"
#include "VCDemo.h"
#include "VCDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg dialog

CVCDemoDlg::CVCDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	init=0;
	counter1=0;
	counter2=0;
}

void CVCDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCDemoDlg)
	DDX_Control(pDX, IDC_NUMLEDCTRL1, m_nLED1);
	DDX_Control(pDX, IDC_NUMLEDCTRL2, m_nLED2);
	DDX_Control(pDX, IDC_NUMLEDCTRL3, m_nLED3);
	DDX_Control(pDX, IDC_NUMLEDCTRL4, m_nLED4);
	DDX_Control(pDX, IDC_NUMLEDCTRL5, m_nLED5);
	DDX_Control(pDX, IDC_NUMLEDCTRL6, m_nLED6);
	DDX_Control(pDX, IDC_NUMLEDCTRL7, m_nLED7);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CVCDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg message handlers

BOOL CVCDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CVCDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}

	if (!init) {
		init = 1;
		SetTimer(1000,2000,NULL);
		SetTimer(1010,500,NULL);
		SetTimer(1020,400,NULL);
		}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CVCDemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CVCDemoDlg)
	ON_EVENT(CVCDemoDlg, IDC_NUMLEDCTRL1, -601 /* DblClick */, OnDblClickNumledctrl1, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_NUMLEDCTRL2, -601 /* DblClick */, OnDblClickNumledctrl2, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_NUMLEDCTRL3, -601 /* DblClick */, OnDblClickNumledctrl3, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_NUMLEDCTRL4, -601 /* DblClick */, OnDblClickNumledctrl4, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_NUMLEDCTRL5, -601 /* DblClick */, OnDblClickNumledctrl5, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_NUMLEDCTRL6, -601 /* DblClick */, OnDblClickNumledctrl6, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_NUMLEDCTRL7, -601 /* DblClick */, OnDblClickNumledctrl7, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CVCDemoDlg::OnDblClickNumledctrl1() 
{
	m_nLED1.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickNumledctrl2() 
{
	m_nLED2.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickNumledctrl3() 
{
	m_nLED3.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickNumledctrl4() 
{
	m_nLED4.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickNumledctrl5() 
{
	m_nLED5.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickNumledctrl6() 
{
	m_nLED6.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickNumledctrl7() 
{
	m_nLED7.ShowPropertyPage();
}

BOOL CVCDemoDlg::DestroyWindow() 
{
	KillTimer(1000);
	KillTimer(1010);
	KillTimer(1020);
	
	return CDialog::DestroyWindow();
}

void CVCDemoDlg::OnTimer(UINT nIDEvent) 
{
CString str,cHour,cMin,cSec,cMSec;
SYSTEMTIME currenttime;
int JulianDate[12]= {0,31,59,90,120,151,181,212,243,273,304,334};
int daynum;

//pad time strings
//random number calculation


	switch (nIDEvent) {
		case 1000: // fast timer
			switch (counter1) {
				case 0:
					GetLocalTime(&currenttime);
					cMin.Format("00%d",currenttime.wMinute);
					str.Format("%d:%s", currenttime.wHour,cMin.Right(2));
					m_nLED6.SetAlphaNumeric(str);
					break;
				case 1:
					m_nLED6.SetAlphaNumeric("+53.1 F");
					break;
				case 2:
					m_nLED6.SetAlphaNumeric("+11.7 C");
					counter1=-1;
					break;
				} 
    
				counter1++;

			break;
		case 1010: // medium speed timer

			srand( (unsigned)time( NULL ) );

			GetLocalTime(&currenttime);

			cHour.Format("00%d",currenttime.wHour);
			cMin.Format("00%d",currenttime.wMinute);
			cSec.Format("00%d",currenttime.wSecond);
			cMSec.Format("000%d",currenttime.wMilliseconds);
		
			str.Format("%s:%s:%s",cHour.Right(2),cMin.Right(2),cSec.Right(2));
			m_nLED1.SetAlphaNumeric(str);

			daynum=JulianDate[currenttime.wMonth-1]+currenttime.wDay;
			if (!(currenttime.wYear%4)) daynum++;
			str.Format("%d:%s:%s:%s.%s",daynum,cHour.Right(2),cMin.Right(2),cSec.Right(2),cMSec.Right(3));
			m_nLED2.SetAlphaNumeric(str);

			counter2++;
			m_nLED3.SetValue(counter2);
			m_nLED4.SetValue(counter2);
			m_nLED5.SetValue(counter2/(3*rand()/10000.0f-1));
		//	str.Format("%g",counter2/(3*rand()/10000.0f-1));
		//	MessageBox(str,NULL,MB_OK);
	
			break;
		case 1020: // slow timer
			if (m_nLED7.GetAlphaNumeric()=="") m_nLED7.SetAlphaNumeric("12:00");
			else m_nLED7.SetAlphaNumeric("");
			break;
		}
	
	CDialog::OnTimer(nIDEvent);
}
